Loading...
Searching...
No Matches
CReducerFinder Class Reference

`#include <syzextra.h>`

## Public Types

typedef long | TComponentKey
typedef std::vector< const CLeadingTerm * > | TReducers

## Public Member Functions

| CReducerFinder (const ideal L, const SchreyerSyzygyComputationFlags &flags)
| goes over all leading terms
void | Initialize (const ideal L)
| ~CReducerFinder ()
poly | FindReducer (const poly multiplier, const poly monom, const poly syzterm, const CReducerFinder &checker) const
poly | FindReducer (const poly product, const poly syzterm, const CReducerFinder &checker) const
bool | IsDivisible (const poly q) const
bool | IsNonempty () const
int | PreProcessTerm (const poly t, CReducerFinder &syzChecker) const
| is the term to be "preprocessed" as lower order term or lead to only reducible syzygies...
Public Member Functions inherited from SchreyerSyzygyComputationFlags
| SchreyerSyzygyComputationFlags (idhdl rootRingHdl)
| SchreyerSyzygyComputationFlags (const SchreyerSyzygyComputationFlags &attr)
void | nextSyzygyLayer () const

## Private Types

typedef std::map< TComponentKey, TReducers > | CReducersHash

## Private Member Functions

| CReducerFinder (const CReducerFinder &)
void | operator= (const CReducerFinder &)

## Private Attributes

ideal | m_L
| only for debug
CReducersHash | m_hash

## Friends

class | CDivisorEnumerator2
class | CDivisorEnumerator

## Additional Inherited Members

Data Fields inherited from SchreyerSyzygyComputationFlags
const int | OPT__DEBUG
| output all the intermediate states
const int | OPT__LEAD2SYZ
| ?
const int | OPT__TAILREDSYZ
| Reduce syzygy tails wrt the leading syzygy terms.
const int | OPT__HYBRIDNF
| Use the usual NF's S-poly reduction while dropping lower order terms 2 means - smart selection!
const int | OPT__IGNORETAILS
| ignore tails and compute the pure Schreyer frame
int | OPT__SYZNUMBER
| Syzygy level (within a resolution).
const int | OPT__TREEOUTPUT
| output lifting tree
const int | OPT__SYZCHECK
| CheckSyzygyProperty: TODO.
const bool | OPT__PROT
| TEST_OPT_PROT.
const int | OPT__NOCACHING
| no caching/stores/lookups
const ring | m_rBaseRing
| global base ring

## Detailed Description

Definition at line 245 of file syzextra.h.

## Member Typedef Documentation

## CReducersHash

typedef std::map< TComponentKey, TReducers> CReducerFinder::CReducersHash

private

Definition at line 257 of file syzextra.h.

## TComponentKey

typedef long CReducerFinder::TComponentKey

Definition at line 253 of file syzextra.h.

## TReducers

typedef std::vector<const CLeadingTerm*> CReducerFinder::TReducers

Definition at line 254 of file syzextra.h.

## Constructor & Destructor Documentation

## CReducerFinder() [1/2]

CReducerFinder::CReducerFinder | ( | const ideal | L,
|  | const SchreyerSyzygyComputationFlags & | flags )

goes over all leading terms

## ~CReducerFinder()

CReducerFinder::~CReducerFinder | ( |  | ) |

## CReducerFinder() [2/2]

CReducerFinder::CReducerFinder | ( | const CReducerFinder & |  | ) |

private

## Member Function Documentation

## FindReducer() [1/2]

poly CReducerFinder::FindReducer | ( | const poly | multiplier,
|  | const poly | monom,
|  | const poly | syzterm,
|  | const CReducerFinder & | checker ) const

## FindReducer() [2/2]

poly CReducerFinder::FindReducer | ( | const poly | product,
|  | const poly | syzterm,
|  | const CReducerFinder & | checker ) const

## Initialize()

void CReducerFinder::Initialize | ( | const ideal | L | ) |

## IsDivisible()

bool CReducerFinder::IsDivisible | ( | const poly | q | ) | const

## IsNonempty()

bool CReducerFinder::IsNonempty | ( |  | ) | const

inline

Definition at line 280 of file syzextra.h.

{ return !m_hash.empty(); }
CReducerFinder::m_hash
CReducersHash m_hash
Definition syzextra.h:288

## operator=()

void CReducerFinder::operator= | ( | const CReducerFinder & |  | ) |

private

## PreProcessTerm()

int CReducerFinder::PreProcessTerm | ( | const poly | t,
|  | CReducerFinder & | syzChecker ) const

is the term to be "preprocessed" as lower order term or lead to only reducible syzygies...

## Friends And Related Symbol Documentation

## CDivisorEnumerator

friend class CDivisorEnumerator

friend

Definition at line 250 of file syzextra.h.

## CDivisorEnumerator2

friend class CDivisorEnumerator2

friend

Definition at line 248 of file syzextra.h.

## Field Documentation

## m_hash

CReducersHash CReducerFinder::m_hash

private

Definition at line 288 of file syzextra.h.

## m_L

ideal CReducerFinder::m_L

private

only for debug

Definition at line 286 of file syzextra.h.

The documentation for this class was generated from the following file:

- Singular/dyn_modules/syzextra/syzextra.h